	subroutine trydel(a,b,qacc)
	include "decl2.f"

	integer a,b,v
	integer sep,sepa,sepb,sepnew
	integer cliq,cliqa,cliqb,cliqab,cliqx,cliqprev,cliqnext
	integer ptrs,nvs,lv,ln,ls,neigh,naccg,lengnew
	integer is,ip1,ip2,iq1,iq2,lc,istklow,ips,iqs,istk
	real rnunf
	real ratio
	logical qacc,qa,qb,findv,same

	integer vs,i
	dimension vs(mxvert)
	

	do i=1,mxvert
	vs(i)=0
	end do

		

	

c.. starting from a clique containing vertex a, find a clique also containing b
c.. start by checking if first one does

	

	cliq = acliq(a)

	

	qb = .false.

	if(findv(b,fvc(cliq))) then
	    qb = .true.
	    cliqab = cliq
	end if

c  push JT edges from cliq onto stack to get started

	istk = 0
	istklow = 0

	neigh = firstn(cliq)
	do while(neigh.ne.0)
	    istk = istk+1
	    st1(istk) = cliq
	    st2(istk) = list(neigh)
	    neigh = link(neigh)
	end do


	
c>B
	do while(istk.gt.istklow)

c pop next new clique from stack

	    cliqprev = st1(istk)
	    cliq = st2(istk)
	    istk = istk-1

c test to see if new clique contains a and b

	    if(findv(a,fvc(cliq))) then
		if(findv(b,fvc(cliq))) then
		    if(qb) then
			if(qqdebug)
     &		write(*,'("reject to prevent non-dec. (1)")')
     			qacc = .false.
			return
		    else
			qb = .true.
			cliqab = cliq
			istklow = istk
		    end if
		end if

c if contained a, scan its neighbours, and push new edges onto stack

		neigh = firstn(cliq)
		do while(neigh.ne.0)
		    cliqnext = list(neigh)
		    if(cliqnext.ne.cliqprev) then
			istk = istk+1
			st1(istk) = cliq
			st2(istk) = cliqnext
		    end if
		    neigh = link(neigh)
		end do
	    end if

c>B
	end do

c.. form pseudo-list for S = copy of cliqab-a-b

c. in vs I create the new list of vertices in S

	ptrs = 0
	nvs = 0
	lv = fvc(cliqab)
	iqs = 0
	do while(lv.ne.0)
		v = list(lv)

		if(v.ne.a.and.v.ne.b) then
		    if(free.eq.0) stop 94
		    ips = free
		    free = link(free)
		    list(ips) = v
		    nvs = nvs+1
    
 
		    vs(nvs)=v


	            if(iqs.eq.0) then
			ptrs = ips
		    else
			link(iqs) = ips
		    end if
		    iqs = ips
		end if

		lv = link(lv)
	end do
	if(iqs.ne.0) link(iqs) = 0
	
	
	
	

c.. now compute Hastings ratio, and decide ................
c   we are proposing deleting edge <ab>, and cliqab is the
c   unique clique containing a and b.




c calculate the ratio	

	
	call getrat(a,b,nvs,ptrs,vs,ratio)
	
	


	if(qqdebug) write(15,'(i3,g13.6)') 2,ratio


	ratio=1.0/ratio
	

	
	

	call putvs(ptrs)

c..........................................................

c>C
	if(rnunf().lt.ratio) then
	naccg = naccg+1
	swchg(min(a,b),max(a,b)) = sweep
	if(qqdebug) write(*,'("... accepted")')



c.. if we get here, edge can be deleted
	
c>D

	if(leng(cliqab).eq.2) then

    		if(firstn(cliqab).eq.0) then
	    
	 
	
c.. case where (ab) is a disconnected clique:
c   make new clique (a) and delete b from (ab)


	




c make new clique (a) and delete a from (ab)

		call getc(cliqa)
		firstn(cliqa) = 0
		firsts(cliqa) = 0

		fvc(cliqa) = 0
		call addv(a,fvc(cliqa))
		leng(cliqa) = 1
		call dropv(a,fvc(cliqab))
		leng(cliqab) = 1
		acliq(a) = cliqa
		acliq(b) = cliqab

	   


	else
c.. (ab) is a clique connected to something: separators are (a) or (b) or both

		qa = .true.
		qb = .true.
		istk = 0
		ln = firstn(cliqab)
		ls = firsts(cliqab)
		do while(ln.ne.0)
		    cliq = list(ln)
		    sep = list(ls)
		    if(list(fvs(sep)).eq.a) then
			if(qa) then
			    qa = .false.
			    cliqa = cliq
			    sepa = sep
			    acliq(a) = cliqa
			else
			    istk = istk+1
			    st1(istk) = cliq
			    st2(istk) = sep
			end if
		    else if(list(fvs(sep)).eq.b) then
			if(qb) then
			    qb = .false.
			    cliqb = cliq
			    sepb = sep
			    acliq(b) = cliqb
			else
			    istk = istk+1
			    st1(istk) = cliq
			    st2(istk) = sep
			end if
		    else
			stop 200
		    end if
		    ln = link(ln)
		    ls = link(ls)
		end do

		do is = 1,istk
		    cliq = st1(is)
		    sep = st2(is)
		    call dropedge(cliqab,cliq,sep)

		    if(list(fvs(sep)).eq.a) then
		    	call addedge(cliqa,cliq,sep)
		    else
		    	call addedge(cliqb,cliq,sep)
		    end if

		end do

		if(qa) then
c b is a separator, remains cliab=a 
		    call dropedge(cliqab,cliqb,sepb)
		    call dropv(b,fvc(cliqab))
		    leng(cliqab) = 1
		    call puts(sepb)

	
	
	
	    
		    
		else if(qb) then
c a is a separator, cliqab=b

 	    call dropedge(cliqab,cliqa,sepa)
		    call dropv(a,fvc(cliqab))
		    leng(cliqab) = 1
		    call puts(sepa)




		    
		else


		    call dropedge(cliqab,cliqa,sepa)
		    call dropedge(cliqab,cliqb,sepb)
		    call putc(cliqab)
		    call puts(sepa)
		    call puts(sepb)
		end if
	    end if

c>D
	else

	
c.. case where (ab) is not the whole clique
c   start by creating new clique (cliqa) 
c and separator (sepnew) containing cliqab-a-b
c   (we later have to modify if S+a or S+b are separators)

	
			
	    call getc(cliqa)
	    firstn(cliqa) = 0
	    firsts(cliqa) = 0

	    if(frees.eq.0) stop 102
	    sepnew = frees
	    frees = links(frees)
	    cliqb = cliqab

	    lv = fvc(cliqb)
	    iq1 = 0
	    iq2 = 0
	    lengnew = 0
	    do while(lv.ne.0)
		if(list(lv).ne.a.and.list(lv).ne.b) then
		    if(free.eq.0) stop 103
		    ip1 = free
		    free = link(free)
		    if(free.eq.0) stop 104
		    ip2 = free
		    free = link(free)
		    list(ip1) = list(lv)
		    list(ip2) = list(lv)
		    lengnew = lengnew+1
		    if(iq1.eq.0) then
			fvs(sepnew) = ip1
			fvc(cliqa) = ip2
		    else
			link(iq1) = ip1
			link(iq2) = ip2
		    end if
		    iq1 = ip1
		    iq2 = ip2
		end if
		lv = link(lv)
	    end do
	    link(iq1) = 0
	    link(iq2) = 0
	    
	    

c.. then add in extra vertex a to cliqa, and drop a from cliqb

	    call dropv(a,fvc(cliqb))
	    call addv(a,fvc(cliqa))
	    leng(cliqb) = leng(cliqb)-1
	    leng(cliqa) = lengnew+1
	    acliq(a) = cliqa

	
c.. then rearrange links between cliques and separators
c first move JT edges that were to cliques containing a to cliqa
c instead of cliqb

	    lc = firstn(cliqb)
	    ls = firsts(cliqb)
	    istk = 0
	    do while(lc.ne.0)
		if(findv(a,fvc(list(lc)))) then
		    istk = istk+1
		    st1(istk) = list(lc)
		    st2(istk) = list(ls)
		end if
		lc = link(lc)
		ls = link(ls)
	    end do

	    do is = 1,istk
	    call dropedge(st1(is),cliqb,st2(is))
	    call addedge(st1(is),cliqa,st2(is))
	    end do

c next insert edge cliqa-sepnew-cliqb
    
	    call addedge(cliqa,cliqb,sepnew)
    
		
c.. if cliqa is a separator, it and the separator need to be bypassed
c   and eliminated

		lc = firstn(cliqa)
		ls = firsts(cliqa)
		do while(lc.ne.0)
			cliq = list(lc)
			sepa = list(ls)
			if(cliq.ne.cliqb) then
				if(same(fvc(cliqa),fvs(sepa))) go to 12
			end if
			lc = link(lc)
			ls = link(ls)
		end do
		
c if we arrive here cliqa is a new clique....I create its matrix of
c probabilities	
	
		
		go to 14
12 		cliqx = cliq
		call dropedge(cliqa,cliqx,sepa)

		lc = firstn(cliqa)
		ls = firsts(cliqa)
		istk = 0
		do while(lc.ne.0)
			istk = istk+1
			st1(istk) = list(lc)
			st2(istk) = list(ls)
			lc = link(lc)
			ls = link(ls)
		end do

		do is = 1,istk
		call dropedge(st1(is),cliqa,st2(is))
		call addedge(st1(is),cliqx,st2(is))
		end do

		lv = fvc(cliqa)
		do while(lv.ne.0)
			v = list(lv)
			acliq(v) = cliqx
			lv = link(lv)
		end do

		call putc(cliqa)
		call puts(sepa)

		cliqa = cliqx

c.. if cliqb is a separator, it and the separator need to be bypassed
c   and eliminated

14		lc = firstn(cliqb)
		ls = firsts(cliqb)
		do while(lc.ne.0)
			cliq = list(lc)
			sepb = list(ls)
			if(cliq.ne.cliqa) then
				if(same(fvc(cliqb),fvs(sepb))) go to 16
			end if
			lc = link(lc)
			ls = link(ls)
		end do

	
		go to 18
16 		cliqx = cliq
		call dropedge(cliqb,cliqx,sepb)

		lc = firstn(cliqb)
		ls = firsts(cliqb)
		istk = 0
		do while(lc.ne.0)
			istk = istk+1
			st1(istk) = list(lc)
			st2(istk) = list(ls)
			lc = link(lc)
			ls = link(ls)
		end do

		do is = 1,istk
		call dropedge(st1(is),cliqb,st2(is))
		call addedge(st1(is),cliqx,st2(is))
		end do

		lv = fvc(cliqb)
		do while(lv.ne.0)
			v = list(lv)
			acliq(v) = cliqx
			lv = link(lv)
		end do

		call putc(cliqb)
		call puts(sepb)


18		continue

	
	



	
c>D	
	end if

	qacc = .true.

		else

	qacc = .false.

	if(qqdebug) write(*,'(".. rejected")')
	

	end if
	

	
	return

	end
