c this subroutine permits to update the graph


	
	subroutine upg(qacc,qnpsd)
	
	
	include "decl2.f"

	integer a,b
	logical qacc,qnpsd
	real rnunf
	
	 
 
 
	
c.. generate vertices a,b at random

	a = min(nv,1+int(nv*rnunf()))
	b = min(nv,1+int(nv*rnunf()))
	
	do while(a.eq.b)
	    b = min(nv,1+int(nv*rnunf()))
	end do
	
		 
	if(adj(a,b)) then

c.. if they are already adjacent, propose deleting edge <ab> ***********
	

	if(qqdebug) write(*,'("sweep:",i7,"  pro. del. edge:",2i4)')
     &	    sweep,a,b

	
	

		call trydel(a,b,qacc)
	
	
	
  
	

		if(qacc) then
	    		adj(a,b) = .false.
	    		adj(b,a) = .false.
	    		edges = edges-1
        	end if

        else
c.. if they are not already adjacent, propose adding edge <ab> ********


	if(qqdebug) write(*,'("sweep:",i7,"  prop. add. edge:",2i4)')
     &	    sweep,a,b


	
	

		call tryadd(a,b,qacc,qnpsd)
		
	
	 
		if(qacc) then
			adj(a,b) = .true.
			adj(b,a) = .true.
			edges = edges+1
		end if

        end if


	



	
	return
	end

c.******************************************************



	subroutine propos(a,b,cliqab,ptrs,nvs,vertexab,prop)
	
c	input: a,b,cliqab,nvs,
c 	output l1,l2


	
	include "decl2.f"

        integer a,b,cliqab,i,ipa,ips,j,lvec,
     &  nvs,pa,pb,ptrs,vas,vbs,var,vertex,vertexab,vs

	real  cond,conda,condb,l1,l2,marga,margb,margs
     	real  prop,mu 
	real den
     
	dimension conda(mxind),condb(mxind), cond(mxind),
     &  marga(mxind),margb(mxind),margs(mxind),	
     &  vas(mxvert),vbs(mxvert),var(mxvert),vertex(mxvert),
     &  vs(mxind),vertexab(2)

	do i=1,mxind
	conda(i)=0.0
	condb(i)=0.0
	marga(i)=0.0
	margb(i)=0.0
	margs(i)=0.0
	 end do

	lvec=2**(nvs+2)
     
c I create the list of vertices of S
	if (ptrs.ne.0) then	
		ips=ptrs

		do i=1,nvs
			vs(i)=list(ips)
			ips=link(ips)
		end do
	end if
	
	
	

c create the list of vertices of cliqab
	
	ipa=fvc(cliqab)
	do i=1,leng(cliqab)
		var(i)=list(ipa)
		ipa=link(ipa)
	end do
	



c I want to create vas containing a and S in ascending order

	if (ptrs.ne.0) then
		call ascend(a,vs,nvs,vas,pa)
	else
		vas(1)=a
		pa=1
	end if
	
	

c. I want to create vbs containing b and S in ascending order
	if (ptrs.ne.0) then
		call ascend(b,vs,nvs,vbs,pb)
	else
		vbs(1)=b
		pb=1
	end if
	


c... marginal of aS obtained by cliqab 
	
	
	call ord(leng(cliqab),nvs+1,var,vas,vertex)	


      call marginal(vertex,cp(fcpc(cliqab)),nvs+1,leng(cliqab),marga)

	call normaliz(marga,2**(nvs+1))
	 				       				 		
c..marginal of bS obatined from  cliqab
	
	call ord(leng(cliqab),nvs+1,var,vbs,vertex)
      call marginal(vertex,cp(fcpc(cliqab)),nvs+1,leng(cliqab),margb)	
	 
	call normaliz(margb,2**(nvs+1))
  
		
c marginal of S obtained from aS

		
	call ord(nvs+1,nvs,vas,vs,vertex)

	call marginal(vertex,marga,nvs,nvs+1,margs)

	
	call normaliz(margs,2**(nvs))
 
	


c conditional distribution of a given S
	


	call condiz(pa,marga,1,nvs+1,margs,conda)	
	
			
c conditional distribution of b given S

	call condiz(pb,margb,1,nvs+1,margs,condb)

	


	
c conditional distribution of ab given S

	call condiz(vertexab(1),cp(fcpc(cliqab)),2,nvs+2,margs,cond)
		
c conda=vector of conditional distribution for a=0
c condb=vector of conditional distribution for b=0

	
  	prop=0.0

	
	j=0
	i=1
	
	 
	
	do i=1,2**nvs
		l1=max(0.0,conda(i)+condb(i)-1.0)
		l2=min(conda(i),condb(i))
			mu=(l1+l2)/2
			call normal(mu,spread,cond(i),den)
				if(den.lt.1E-40) then 
			 den=1E-40
	end if
	if(den.le.0.0) stop 13
	if(margs(i).le.0.0) stop 14
		 prop=prop+log(den)-log(margs(i))
      end do	
	
	
	return
	end
	

c*****************************

c	input prop,a,b,cliq,nvs,ptrs

c output ratio	

	subroutine getrat1(a,b,cliq,nvs,ptrs,vs,prop,ratio)

	include "decl2.f"
	
	
	
	integer a,b,nvs,p,ptrs,cliq,vabs,vas,
     &  vbs,vertex,vs,i

	dimension vas(mxvert),vbs(mxvert),vs(mxvert),
     &  vertex(mxvert),vabs(mxvert)


	real prop
       
	real lograt

      real hx,hxa,hxb,hxab

      real ratio

	real marg,marga,margn 

	dimension marg(mxind),marga(mxind),margn(mxind)
       
	do i=1,mxvert
	vas(i)=0
	vbs(i)=0
	vertex(i)=0
	vabs(i)=0
	end do

	
	
 	 

	if(model.eq.0) then
        	ratio = 1.0
        	else
      ratio=0.0

c create vabs containing the vertex in cliq

	   if(ptrs.eq.0) then
		vas(1)=a
		vbs(1)=b
		if(a.gt.b) then
			vabs(1)=b
			vabs(2)=a
		else
			vabs(1)=a
			vabs(2)=b
		end if
           else
		call ascend(a,vs,nvs,vas,p)
		call ascend(b,vas,nvs+1,vabs,p)
	   end if

	 
c.. calculate required quantities on S

	
          if(ptrs.eq.0) then

             hx = 0.0

          else


            call ord(nvs+2,nvs,vabs,vs,vertex)
	     	                   
            call marginal(vertex,cp(fcpc(cliq)),nvs,nvs+2,marg)
	call normaliz(marg,2**nvs)
				
            call marginal(vs,alpiniz(1),nvs,nv,marga) 
	
		  call marginal(vs,noss(1),nvs,nv,margn)

	 
c local part of the ratio
      	    
			
	       call hloc1(marg,marga,margn,2**nvs,hx)
		
			 
             end if

		
	
c.. calculate quantities on S+a

             call ord(nvs+2,nvs+1,vabs,vas,vertex)

             call marginal(vertex,cp(fcpc(cliq)),nvs+1,nvs+2,marg)

	call normaliz(marg,2**(nvs+1))
             call marginal(vas,alpiniz(1),nvs+1,nv,marga)

		   call marginal(vas,noss(1),nvs+1,nv,margn)	

             call hloc1(marg,marga,margn,2**(nvs+1),hxa)
	
	
c.. calculate quantities on S+b
               
              call ascend(b,vs,nvs,vbs,p)	
    
              call ord(nvs+2,nvs+1,vabs,vbs,vertex)
             
              call marginal(vertex,cp(fcpc(cliq)),nvs+1,nvs+2,marg)

	        call normaliz(marg,2**(nvs+1))

	        call marginal(vbs,alpiniz(1),nvs+1,nv,marga)

			call marginal(vbs,noss(1),nvs+1,nv,margn)

			call hloc1(marg,marga,margn,2**(nvs+1),hxb)
	
	
c.. calculate quantities on S+a+b

         call marginal(vabs,alpiniz(1),nvs+2,nv,marga)

	   call marginal(vabs,noss(1),nvs+2,nv,margn)


	

	   call hloc1(cp(fcpc(cliq)),marga,margn,2**(nvs+2),hxab)
	
		  	 

	
c.. calculate ratio
	

	 
		 lograt= hx-hxa-hxb+hxab-prop
		 
		 ratio=exp(max(-20.0,min(20.0,lograt))) 
	
     
     		
	
	       	
	
      end if


        return

        end
c**************************************************************************
	subroutine hloc1(vecp,veca,vecn,l,h)

	
	include "decl2.f"
		
	integer i,l
	real vecp(mxind),veca(mxind),vecn(mxind)

	real h,h1,h2,h3, alngam,sum
	
	
	


		h1=	alngam(atot)  
	
		 
	sum=0.0
	do i=0,l-1
	sum=sum+alngam(veca(i+1))
	end do

	h2=sum
 
	sum=0.0
	
	
	 
 


	do i=0,l-1

	if(vecp(1+i).le.0.0)  then
	stop 22
	end if
	   


			sum=sum+(veca(1+i)+vecn(i+1)-1)*log(vecp(1+i))

	end do

	

	h3=sum

	h=h1-h2+h3
	
	
	

	return
	end


c@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

	subroutine hloc2(vecp,veca,l,h)
c. to be used for the local part of ratio
	
	
	include "decl2.f"
		
	integer i,l
	real vecp(mxind),veca(mxind)
c,vecn(mxind)

	real h,h1,h2,h3, alngam,sum
	
	
	


		h1=	alngam(atot)  
	
		 
	sum=0.0
	do i=0,l-1

	sum=sum+alngam(veca(i+1))
	end do

	h2=sum
 
	sum=0.0
	
	
	do i=0,l-1
	if(vecp(1+i).le.0.0) stop  23
		sum=sum+(veca(1+i)-1)*log(vecp(1+i))
	end do

	

	h3=sum

	h=h1-h2+h3
	
	
	
	 return
	end

